/**
 * RWD Table with freezing head and columns for jQuery
 * 
 * @author  Nick Tsai <myintaer@gmail.com>
 * @version 1.1.5
 * @see     https://github.com/yidas/jquery-freeze-table
 */
!function(t,s){"use strict";var e=function(s,e){return this.$tableWrapper=t(s).first(),this.options=e||{},this.namespace=this.options.namespace||"freeze-table",this.callback,this.shadow,this.fastMode,this.backgroundColor,this.$table=this.$tableWrapper.children("table"),this.$headTableWrap,this.$columnTableWrap,this.$columnHeadTableWrap,this.$scrollBarWrap,this.fixedNavbarHeight,this.isWindowScrollX=!1,this.headWrapClass="clone-head-table-wrap",this.columnWrapClass="clone-column-table-wrap",this.columnHeadWrapClass="clone-column-head-table-wrap",this.scrollBarWrapClass="clone-scroll-bar-wrap",this.init(),this};e.prototype.init=function(){if(!this.$table.length)throw"The element must contain a table dom";if("update"===this.options)this.destroy(),this.options=this.$tableWrapper.data("freeze-table-data");else{if("resize"===this.options)return this.options=this.$tableWrapper.data("freeze-table-data"),this.namespace=this.options.namespace||this.namespace,void this.resize();this.$tableWrapper.data("freeze-table-data",this.options)}var e=this.options,i=void 0===e.freezeHead||e.freezeHead,a=void 0===e.freezeColumn||e.freezeColumn,l=void 0===e.freezeColumnHead||e.freezeColumnHead,o=void 0!==e.scrollBar&&e.scrollBar,r=e.fixedNavbar||".navbar-fixed-top",h=e.callback||null;this.namespace=this.options.namespace||this.namespace,this.shadow=void 0!==e.shadow&&e.shadow,this.fastMode=void 0!==e.fastMode&&e.fastMode,this.backgroundColor=e.backgroundColor||"white",this.fixedNavbarHeight=r&&t(r).outerHeight()||0,this.isInit()&&this.destroy(),this.$tableWrapper.css("height","100%").css("min-height","100%").css("max-height","100%"),i&&this.buildHeadTable(),a&&(this.buildColumnTable(),this.$tableWrapper.css("overflow-x","scroll")),l&&i&&a&&this.buildColumnHeadTable(),o&&this.buildScrollBar();var n=function(){t(s).scrollLeft()>0?(this.isWindowScrollX=!0,this.$headTableWrap&&this.$headTableWrap.css("visibility","hidden"),this.$columnTableWrap&&this.$columnTableWrap.css("visibility","hidden"),this.$columnHeadTableWrap&&this.$columnHeadTableWrap.css("visibility","hidden"),this.$scrollBarWrap&&this.$scrollBarWrap.css("visibility","hidden")):this.isWindowScrollX=!1}.bind(this);t(s).on("scroll."+this.namespace,function(){n()}),this.resize(),"function"==typeof h&&h()},e.prototype.buildHeadTable=function(){var e=this,i=this.clone(this.$table);if(this.fastMode)i=this.simplifyHead(i);var a=this.options.headWrapStyles||null;this.$headTableWrap=t('<div class="'+this.headWrapClass+'"></div>').append(i).css("position","fixed").css("overflow","hidden").css("visibility","hidden").css("top",0+this.fixedNavbarHeight).css("z-index",2),this.shadow&&this.$headTableWrap.css("box-shadow","0px 6px 10px -5px rgba(159, 159, 160, 0.8)"),a&&"object"==typeof a&&t.each(a,function(t,s){e.$headTableWrap.css(t,s)}),this.$tableWrapper.append(this.$headTableWrap),this.$tableWrapper.on("scroll."+this.namespace,function(){e.$headTableWrap.scrollLeft(t(this).scrollLeft())}),t(s).on("scroll."+this.namespace,function(){var i=t(s).scrollTop()+e.fixedNavbarHeight;e.$table.offset().top-1<=i&&e.$table.offset().top+e.$table.outerHeight()-1>=i?e.$headTableWrap.css("visibility","visible"):e.$headTableWrap.css("visibility","hidden")}),t(s).on("resize."+this.namespace,function(){e.$headTableWrap.css("width",e.$tableWrapper.width()),e.$headTableWrap.css("height",e.$table.find("thead").outerHeight())})},e.prototype.buildColumnTable=function(){var e=this,i=this.options.columnWrapStyles||null,a=this.options.columnNum||1,l=void 0!==this.options.columnKeep&&this.options.columnKeep,o=this.shadow?0:1,r=void 0!==this.options.columnBorderWidth?this.options.columnBorderWidth:o,h=this.clone(this.$table);this.$columnTableWrap=t('<div class="'+this.columnWrapClass+'"></div>').append(h).css("position","fixed").css("overflow","hidden").css("visibility","hidden").css("z-index",1),this.shadow&&this.$columnTableWrap.css("box-shadow","6px 0px 10px -5px rgba(159, 159, 160, 0.8)"),i&&"object"==typeof i&&t.each(i,function(t,s){e.$columnTableWrap.css(t,s)}),this.$tableWrapper.append(this.$columnTableWrap);var n=function(){e.$columnTableWrap.css("top",e.$table.offset().top-t(s).scrollTop())};l?this.$columnTableWrap.css("visibility","visible"):this.$tableWrapper.on("scroll."+this.namespace,function(){e.isWindowScrollX||(t(this).scrollLeft()>0?e.$columnTableWrap.css("visibility","visible"):e.$columnTableWrap.css("visibility","hidden"))}),t(s).on("resize."+this.namespace,function(){h.width(e.$table.width());for(var t=0+r,s=1;s<=a;s++){var i=e.$table.find("th:nth-child("+s+")").outerWidth();t+=i>0?i:e.$table.find("td:nth-child("+s+")").outerWidth()}e.$columnTableWrap.width(t),n()}),t(s).on("scroll."+this.namespace,function(){n()})},e.prototype.buildColumnHeadTable=function(){var e=this;this.$columnHeadTableWrap=this.clone(this.$headTableWrap),this.fastMode&&(this.$columnHeadTableWrap=this.simplifyHead(this.$columnHeadTableWrap));var i=this.options.columnHeadWrapStyles||null;this.$columnHeadTableWrap.removeClass(this.namespace).addClass(this.columnHeadWrapClass).css("z-index",3),this.shadow&&this.$columnHeadTableWrap.css("box-shadow","none"),i&&"object"==typeof i&&t.each(i,function(t,s){this.$columnHeadTableWrap.css(t,s)}),this.$tableWrapper.append(this.$columnHeadTableWrap);var a=function(){var i=t(s).scrollTop()+e.fixedNavbarHeight;e.$table.offset().top-1<=i&&e.$table.offset().top+e.$table.outerHeight()-1>=i&&e.$tableWrapper.scrollLeft()>0?e.$columnHeadTableWrap.css("visibility","visible"):e.$columnHeadTableWrap.css("visibility","hidden")};t(s).on("scroll."+this.namespace,function(){a()}),this.$tableWrapper.on("scroll."+this.namespace,function(){e.isWindowScrollX||a()}),t(s).on("resize."+this.namespace,function(){e.$columnHeadTableWrap.find("> table").css("width",e.$table.width()),e.$columnHeadTableWrap.css("width",e.$columnTableWrap.width()),e.$columnHeadTableWrap.css("height",e.$table.find("thead").outerHeight())})},e.prototype.buildScrollBar=function(){var e=this,i=this.$table.find("thead").outerHeight(),a=t('<div class="'+this.scrollBarWrapClass+'"></div>').css("width",this.$table.width()).css("height",1);this.$scrollBarWrap=t('<div class="'+this.scrollBarWrapClass+'"></div>').css("position","fixed").css("overflow-x","scroll").css("visibility","hidden").css("bottom",0).css("z-index",2).css("width",this.$tableWrapper.width()).css("height",20),this.$scrollBarWrap.append(a),this.$tableWrapper.append(this.$scrollBarWrap),this.$scrollBarWrap.on("scroll."+this.namespace,function(){e.$tableWrapper.scrollLeft(t(this).scrollLeft())}),this.$tableWrapper.on("scroll."+this.namespace,function(){e.$scrollBarWrap.scrollLeft(t(this).scrollLeft())}),t(s).on("scroll."+this.namespace,function(){var a=t(s).scrollTop()+t(s).height()-i+e.fixedNavbarHeight;e.$table.offset().top-1<=a&&e.$table.offset().top+e.$table.outerHeight()-1>=a?e.$scrollBarWrap.css("visibility","visible"):e.$scrollBarWrap.css("visibility","hidden")}),t(s).on("resize."+this.namespace,function(){a.css("width",e.$table.width()),e.$scrollBarWrap.css("width",e.$tableWrapper.width())})},e.prototype.clone=function(s){return t(s).clone().removeAttr("id").css("background-color",this.backgroundColor)},e.prototype.simplifyHead=function(s){var e=this,i=t(s);return i.find("> tr, > tbody, > tfoot").remove(),t.each(i.find("> thead > tr:nth-child(1) >"),function(s,i){var a=e.$table.find("> thead > tr:nth-child(1) > :nth-child("+parseInt(s+1)+")").outerWidth();t(this).css("width",a)}),i},e.prototype.isInit=function(){return!!this.$tableWrapper.find("."+this.headWrapClass).length||(!!this.$tableWrapper.find("."+this.columnWrapClass).length||(!!this.$tableWrapper.find("."+this.columnHeadWrapClass).length||!!this.$tableWrapper.find("."+this.scrollBarWrapClass).length))},e.prototype.unbind=function(){t(s).off("resize."+this.namespace),t(s).off("scroll."+this.namespace),this.$tableWrapper.off("scroll."+this.namespace)},e.prototype.destroy=function(){this.unbind(),this.$tableWrapper.find("."+this.headWrapClass).remove(),this.$tableWrapper.find("."+this.columnWrapClass).remove(),this.$tableWrapper.find("."+this.columnHeadWrapClass).remove(),this.$tableWrapper.find("."+this.scrollBarWrapClass).remove()},e.prototype.resize=function(){return t(s).trigger("resize."+this.namespace),t(s).trigger("scroll."+this.namespace),this.$tableWrapper.trigger("scroll."+this.namespace),!0},e.prototype.update=function(){return this.options="update",this.init(),this},s.FreezeTable=e,t.fn.freezeTable=function(t){if(1===this.length)return new e(this,t);if(this.length>1){var s=[];return this.each(function(){s.push(new e(this,t))}),s}return!1}}(jQuery,window);
